require('./AccordionItem.scss');
import React from 'react';
import classnames from 'classnames';
import Animate from 'rc-animate';
import ItemContent from './ItemContent.js';

export default class AccordionItem extends React.Component {

  render() {
    const itemClasses = {
      'accordion-item': true,
      'is-active': this.props.active
    };

    return (
      <div className={classnames(itemClasses)} role='tablist'>
        <div className='accordion-title' onClick={this.props.activate} role='tab'>
          {this.props.title}
        </div>
        <Animate
          component=""
          showProp="active"
          exclusive={false}
          transitionName="fade"
          transitionAppear={true}>
          <ItemContent active={this.props.active} children={this.props.children} />
        </Animate>
      </div>
    );
  }
}
