import React from 'react';
import classnames from 'classnames';

export default class Tab extends React.Component {

  componentDidMount() {
    if (this.props.active) {
      this.select();
    }
  }

  select() {
    var options = {
      selectedTab: this.props.index,
      content: this.props.children
    };
    this.props.selectTab(options);
  }

  render() {
    var classes = {
      'tabs-title': true,
      'is-active': this.props.active
    };
    return (
      <li className={classnames(classes)} onClick={this.select.bind(this)}>
        <a aria-selected={this.props.active}>{this.props.title}</a>
      </li>
    );
  }
}
