import React, { cloneElement } from 'react';

export default class Tabs extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      selectedTab: 0,
      content: null
    };
  }

  selectTab(options) {
    this.setState(options);
  }

  render() {
    var children = React.Children.map(this.props.children, function (child, index) {
      return cloneElement(child, {
        active: (index === this.state.selectedTab),
        index: index,
        selectTab: this.selectTab.bind(this)
      });
    }.bind(this));
    return (
      <div>
        <ul className="tabs">{children}</ul>
        <div>{this.state.content}</div>
      </div>
    );
  }
}
